#include <stdio.h>

#define PBCS		0x93		/* Z8036 #2 port B cmd & stat reg */
#define PBDDR		0x57
#define PCDD		0x0D
#define PCDATA		0x1F
#define PBDATA		0x1D
#define CLRIPIUS	0x20		/* Mask to clear IP and IUS */
#define MCCR		0x03
#define	MICR		0x01
#define PBCSR		0x13
#define SIOCRC		0x0F

/*
 *
 *
 *
 * The data lines are initialised, as follows in md.s:
 *	8036 #1, port b, non-inverting:			output data lines
 *	8036 #1, port c, bit 0, non-inverting:		input busy line
 *	8036 #2, port b, bit 1, inverting:		inpupt acknowledge
 *	8036 #2, port c,  bit 3, non-inverting:		output strobe
 *	
 */



main()
{
	register int fd;
	int i, status;
	unsigned int tmp;

	initio();

	fd = open("/dev/port", 2);

	printf("Begin . . .\n");

	outb( fd, PCDATA, inb(fd, PCDATA) & 0x0F); /* enable 0-3 write */
	outb( fd, PCDATA, inb(fd, PCDATA) | 0x02); 	/* set select = 1 */
	outb( fd, PCDD, 0x05);		/* set up CS line	*/
	outb( fd, PCDATA, inb(fd, PCDATA) | 0x02); 	/* set select = 1 */

	outb( fd, PBDATA, 0);

/*	outb( fd, PBDATA, inb(fd, PBDATA) | 0x80);	 set stop = 1	*/
	outb( fd, PCDATA, inb(fd, PCDATA) & ~0x02); 	/* set select = 0 */
	printf("select on\n");

	wrt( 0x0D, 0, fd);

	printf(" loop . . .\n");

	for( i = 0; i < 13; ++i)
		printf("i = %u data = %u\n", i, red(i, fd));

/*	for( i = 0; i < 12 ; ++i)
		wrt( i, 1, fd);
*/

/*	outb( fd, PBDATA, inb(fd, PBDATA) & ~0x80);	set stop = 0	*/
	outb( fd, PCDATA, inb(fd, PCDATA) | 0x02);	/* set select =1 */

	cloio();

}
red(reg, fd)
int fd;
unsigned int reg;
{
	unsigned int tmp;

/*	outb(fd, PBDATA, (inb(fd, PBDATA) & 0xF0) | reg); */
	outb(fd, PBDATA, reg);

	outb(fd, PBDATA, (inb(fd, PBDATA) | 0x40));
	tmp = 5 * 5;
	outb(fd, PBDATA, (inb(fd, PBDATA) & ~0x40));
/*
 * make PB0-3 input lines
 */
	outb(fd, PBDDR, (inb(fd, PBDDR) | 0x0F));

	tmp = 5 * 3 * 4;
	outb(fd, PBDATA, (inb(fd, PBDATA) | 0x10));
	tmp = 9 * 8 * 9;
	tmp = inb(fd, PBDATA) & 0x0F;
	outb(fd, PBDATA, (inb(fd, PBDATA) & ~0x10));
/*
 * make PB0-3 output lines
 */
	outb(fd, PBDDR, (inb(fd, PBDDR) & 0xF0));

	return(tmp);
}

wrt(reg, data, fd)
int fd;
unsigned int reg;
unsigned int data;
{
	unsigned int tmp;
/*	outb(fd, PBDATA, (inb(fd, PBDATA) & 0xF0) | reg); */
	outb(fd, PBDATA, reg);

	outb(fd, PBDATA, (inb(fd, PBDATA) | 0x40));
	tmp = 5 * 5;
	outb(fd, PBDATA, (inb(fd, PBDATA) & ~0x40));
	tmp = 5 * 3;
	outb(fd, PBDATA, ((inb(fd, PBDATA) & 0xF0) | data));
	outb(fd, PBDATA, (inb(fd, PBDATA) | 0x20));
	tmp = 3 * 4 * 7;
	outb(fd, PBDATA, (inb(fd, PBDATA) & ~0x20));

}

dumpreg(fd)
int fd;
{
	printf("\nPBDDR:\t%x\n", inb(fd, PBDDR));
	printf("PCDDR:\t%x\n", inb(fd, PCDD));
	printf("PBDATA:\t%x\n", inb(fd, PBDATA));
	printf("PCDATA:\t%x\n", inb(fd, PCDATA));
	printf("MICR:\t%x\n", inb(fd, MICR));
	printf("MCCR:\t%x\n", inb(fd, MCCR));
	printf("PBCSR:\t%x\n", inb(fd, PBCSR));
	printf("SIOCRC:\t%x\n\n", inb(fd, SIOCRC));

}
