#include <stdio.h>

#define PBCS		0x93		/* Z8036 #2 port B cmd & stat reg */
#define PBDDR		0x57
#define PCDD		0x0D
#define PCDATA		0x1F
#define PBDATA		0x1D
#define CLRIPIUS	0x20		/* Mask to clear IP and IUS */
#define MCCR		0x03
#define	MICR		0x01
#define PBCSR		0x13
#define SIOCRC		0x0F

/*
 *
 *
 *
 * The data lines are initialised, as follows in md.s:
 *	8036 #1, port b, non-inverting:			output data lines
 *	8036 #1, port c, bit 0, non-inverting:		input busy line
 *	8036 #2, port b, bit 1, inverting:		inpupt acknowledge
 *	8036 #2, port c,  bit 3, non-inverting:		output strobe
 *	
 */



main()
{
	register int fd;
	int i, status;
	unsigned int tmp;
	char *day[6], *month[12];

	day[0] = "Sun";
	day[1] = "Mon";
	day[2] = "Tue";
	day[3] = "Wed";
	day[4] = "Thu";
	day[5] = "Fri";
	day[6] = "Sat";
	month[0] = "Jan";
	month[1] = "Feb";
	month[2] = "Mar";
	month[3] = "Apr";
	month[4] = "May";
	month[5] = "Jun";
	month[6] = "Jul";
	month[7] = "Aug";
	month[8] = "Sep";
	month[9] = "Oct";
	month[10] = "Nov";
	month[11] = "Dec";

	initio();

	fd = open("/dev/port", 2);

dumpreg(fd);

	outb( fd, PCDATA, inb(fd, PCDATA) & 0x0F); /* enable 0-3 write */
	outb( fd, PCDATA, (inb(fd, PCDATA) & 0x0F) | 0x02); /* set select = 1 */
	outb( fd, PCDD, 0x05);		/* set up CS line	*/
	outb( fd, PCDATA, (inb(fd, PCDATA) & 0x0F) | 0x02); /* set select = 1 */

	outb( fd, PBDATA, 0);
dumpreg(fd);
	outb( fd, PBDATA, inb(fd, PBDATA) | 0x80);	/* set stop = 1 */
	outb( fd, PCDATA, inb(fd, PCDATA) & 0x0D); 	/* set select = 0 */
dumpreg(fd);
	printf("select on\n");

	wrt( 0x0D, 0, fd);

	wrt(0x00, 0, fd);
	wrt(0x01, 3, fd);
	wrt(0x02, 9, fd);
	wrt(0x03, 5, fd);
	wrt(0x04, 3, fd);
	wrt(0x05, 8+2, fd);	/* set 24 hour mode */
	wrt(0x06, 6, fd);
	wrt(0x07, 1, fd);
	wrt(0x08, 3, fd);
	wrt(0x09, 2, fd);
	wrt(0x0a, 1, fd);

	wrt(0x0b, 5, fd);
	wrt(0x0c, 8, fd);

	wrt(0x0d, 0, fd);

	outb( fd, PBDATA, inb(fd, PBDATA) & ~0x80);	/* set stop = 0 */
	outb( fd, PCDATA, (inb(fd, PCDATA) & 0x0F) | 0x02); /* set select = 1 */
dumpreg(fd);
	cloio();

}
red(reg, fd)
int fd;
unsigned int reg;
{
	unsigned int tmp;

	outb(fd, PBDATA, (inb(fd, PBDATA) & 0xF0) | reg);
/*	outb(fd, PBDATA, reg);	*/

	outb(fd, PBDATA, (inb(fd, PBDATA) | 0x40));
	tmp = 5 * 5;
	outb(fd, PBDATA, (inb(fd, PBDATA) & ~0x40));
/*
 * make PB0-3 input lines
 */
	outb(fd, PBDDR, (inb(fd, PBDDR) | 0x0F));

	tmp = 5 * 3 * 4;
	outb(fd, PBDATA, (inb(fd, PBDATA) | 0x10));
	tmp = 9 * 8 * 9;
	tmp = inb(fd, PBDATA) & 0x0F;
	outb(fd, PBDATA, (inb(fd, PBDATA) & ~0x10));
/*
 * make PB0-3 output lines
 */
	outb(fd, PBDDR, (inb(fd, PBDDR) & 0xF0));

	return(tmp);
}

wrt(reg, data, fd)
int fd;
unsigned int reg;
unsigned int data;
{
	unsigned int tmp;
	outb(fd, PBDATA, (inb(fd, PBDATA) & 0xF0) | reg);
/*	outb(fd, PBDATA, reg);		*/

	outb(fd, PBDATA, (inb(fd, PBDATA) | 0x40));
	tmp = 5 * 5;
	outb(fd, PBDATA, (inb(fd, PBDATA) & ~0x40));
	tmp = 5 * 3;
	outb(fd, PBDATA, ((inb(fd, PBDATA) & 0xF0) | data));
	outb(fd, PBDATA, (inb(fd, PBDATA) | 0x20));
	tmp = 3 * 4 * 7;
	outb(fd, PBDATA, (inb(fd, PBDATA) & ~0x20));

}

dumpreg(fd)
int fd;
{
	printf("\nPBDDR:\t%x\n", inb(fd, PBDDR));
	printf("PCDDR:\t%x\n", inb(fd, PCDD));
	printf("PBDATA:\t%x\n", inb(fd, PBDATA));
	printf("PCDATA:\t%x\n", inb(fd, PCDATA));
	printf("MICR:\t%x\n", inb(fd, MICR));
	printf("MCCR:\t%x\n", inb(fd, MCCR));
	printf("PBCSR:\t%x\n", inb(fd, PBCSR));
	printf("SIOCRC:\t%x\n\n", inb(fd, SIOCRC));

}
