/*
 * Machine dependent keyboard definitions.
 */

#define	SPC	0376			/* Special encoding */
#define XXX	0377			/* Non-character */
#define	KBDATA	0x60			/* Keyboard data */
#define	KBCTRL	0x61			/* Keyboard control */
#define	KBFLAG	0x80			/* Keyboard reset flag */

#define	KEYUP	(0x80)			/* Key up change */
#define	KEYSC	(0x7F)			/* Key scan code mask */
#define	LSHIFT	(0x2A)			/* Left shift key */
#define LSHIFTA (0x2B)			/* Alternate left-shift key */
#define	RSHIFT	(0x36)			/* Right shift key */
#define	CTRL	(0x1D)			/* Control key */
#define	ALT	(0x38)			/* Alt key */
#define	CAPLOCK	(0x3A)			/* Caps lock key */
#define	DELETE	(0x53)			/* Del, as in CTRL-ALT-DEL */
#define BACKSP	(0x0E)			/* Back space */
#define SCRLOCK	(0x46)			/* Scroll lock */

/* Shift flags */
#define	SRS	(0x01)			/* Right shift key on */
#define	SLS	(0x02)			/* Left shift key on */
#define CTS	(0x04)			/* Ctrl key on */
#define ALS	(0x08)			/* Alt key on */
#define CPLS	(0x10)			/* Caps lock on */
#define NMLS	(0x20)			/* Num lock on */
#define AKPS	(0x40)			/* Alternate keypad shift */
#define SHFT	(0x80)			/* Shift key flag */
