/*
 * Commodore Z8000-HR console
 */
#include	<coherent.h>
#include	<con.h>
#include	<io.h>
#include	<uproc.h>
#include	<errno.h>
#include	<sched.h>
#include	<sgtty.h>
#include	<signal.h>
#include	<stat.h>
#include	<ioport.h>

#define	MAJOR	11		/* major device # of the console */
#define	PIOINW	1		/* input word		*/
#define	PIOINB	2		/* input byte		*/
#define	PIOOUTW	3		/* output word		*/
#define	PIOOUTB	4		/* output byte		*/

struct pio
{
	unsigned paddr;		/* port address		*/
	unsigned pdata;		/* port data		*/
};

int	ptioctl( ),
	ptload,
	ptuload,
	nulldev();


CON ptcon = {
	DFCHR,
	MAJOR,
	nulldev,
	nulldev,
	nulldev,
	nulldev,
	nulldev,
	ptioctl,
	nulldev,
	nulldev,
	ptload,
	ptuload
};



ptload()
{
	int	i;
	printf("Sound load\n");
	for(i = 0; i < 5000; i++) {
		outb(CIO1 | PBD, 00);
		outb(CIO1 | PBD, 01);
	}
	printf("done\n");
}

ptuload()
{
	printf("Sound unload\n");
}

ptioctl( dev, com, args)
dev_t	dev;
int	*args;
{
	register unsigned self;
	struct	 pio	  pio;

	self = minor( dev);

	if ( com != PIOINB && com != PIOINW && com != PIOOUTW && com != PIOOUTB )
		return;
	ukcopy(args, &pio, sizeof(pio));
	if ( u.u_error )
		return;

	if ( com == PIOOUTW )
	{
		out(pio.paddr, pio.pdata);
		return;
	}
	else if ( com == PIOOUTB )
	{
		outb(pio.paddr, pio.pdata);
		return;
	}
	else if (com == PIOINB )
		pio.pdata = inb(pio.paddr) & 0xff;
	else
		pio.pdata = in(pio.paddr);
	kucopy(&pio, args, sizeof(pio));
}
