/*
 * @(#)fgets.c	1.1 15:34:37 4/6/85";
 *
 * replace some of the stdio stuff
 *	getc()
 *	ungetc()
 *	fgets()
 *
 * NOTE: these functions only approximate their stdio counterparts
 * they only work on one file at a time. This saves us an unbelievable
 * amount of code. They also use file descriptors NOT FILE *.
 */

#define	BUFSIZ	512
#define	EOF	-1
static	char	Inbuf[BUFSIZ] = {0};
static	int	Incnt = 0;
static	int	Insiz = 0;
static	char	*Inptr = 0;

clribuf()
{
	Incnt = Insiz = 0;
	Inptr = Inbuf;
}

getc(fd)
int	fd;
{
	if ( Incnt >= Insiz )
	{
		Incnt = 0;
		Inptr = Inbuf;
		Insiz = read(fd, Inbuf, BUFSIZ);
		if ( Insiz <= 0 )
			return ( EOF );
	}
	Incnt++;
	return ( (int) *Inptr++ );
}

ungetc(c)
char	c;
{
	if ( Incnt > 0 )
	{
		Incnt--;
		*(--Inptr) = c;
	}
	else
	{
		Inbuf[0] = c;
		Incnt = 0;
		Insiz = 1;
	}
}

char	*fgets(str, max, fd)
char	*str;
int	max;
int	fd;
{
char	*buf;
char	i;

	buf = str;
	while ( --max > 0 )			/* read max - 1 chars */
	{
		i = getc(fd);
		if (i == EOF )
			break;
		*buf++ = i;
		if ( i == '\n' )		/* fgets keeps the newline */
			break;
	}
	*buf = '\0';
	if ( buf == str )			/* nothing read returns NULL */
		return ((char *) 0);
	return ( str );
}
